
\section*{Syntax}

\begin{flalign*}
    &\text{Kinds} &\kappa &::= \star \mid \kappa \to \kappa \\[.5em]
    &\text{Types} &A &::= \oldhat{\alpha} \mid \alpha \mid 1 \mid A \to B \mid \forall \alpha :: \kappa. A \mid \lambda \alpha :: \kappa. A \mid A \ B \mid \Pi \ \rho_A \mid \Sigma \ \rho_A \\[.5em]
    &\text{Monotype} &\tau &::= \oldhat{\alpha} \mid \alpha \mid 1 \mid \tau \to \sigma \mid \lambda \alpha :: \kappa. \tau \mid \tau \ \sigma \mid \Pi \ \rho_\tau \mid \Sigma \ \rho_\tau \\[.5em]
    &\text{Rows} &\rho_X &::= \cdot \mid \ell : X :: \rho \\[.5em]
    &\text{Row Label} &\ell, C \\[.5em]
    &\text{Terms} &e &::= x \mid \lambda x. e \mid \lambda (x : A).e \mid e \ e \mid () \mid (e : A) \mid \Lambda \alpha :: \kappa. e \\
    &&&\hspace*{5mm}\mid \textsf{let } x = e \textsf{ in } e \mid \textsf{let type } \alpha :: \kappa = A \textsf{ in } e\\
    &&&\hspace*{5mm}\mid \textsf{let rec } f : A = \lambda x. e \textsf{ in } e \\
    &&&\hspace*{5mm}\mid C \ f \mid \textsf{match } f \textsf{ with } \overline{p \rightarrow f} \\
    &&&\hspace*{5mm}\mid \{ \ \ell = f; \ldots; \ell = f \ \} \mid f.\ell \mid \{ \ f \textsf{ with } \ell = f \ \} \\[.5em]
    &\text{Contexts} &\Gamma &::= \cdot \mid \Gamma, x : A \mid \Gamma, \alpha :: \kappa \mid \Gamma, \alpha :: \kappa = A \mid \Gamma, \rhd_{\oldhat{\alpha}} \mid \Gamma, \oldhat{\alpha} :: \kappa \mid \Gamma, \oldhat{\alpha} :: \kappa = \tau \\[.5em]
    &\text{Variance} &\nu &::= + \mid - \mid \pm
\end{flalign*}

\section*{Typing Rules}
\noindent$\boxed{\Gamma \textsf{ ctx}}$
\begin{mathpar}
    \inferrule*[]
        { }
        { \cdot \textsf{ ctx}}
    
    \inferrule*[]
        { \Gamma \textsf{ ctx} \\ \Gamma \vdash A :: \star \\ x \notin \dom \Gamma}
        { \Gamma, x : A \textsf{ ctx}}

    \inferrule*[]
        { \Gamma \textsf{ ctx} \\ \alpha \notin \dom \Gamma }
        { \Gamma, \alpha :: \kappa \textsf{ ctx} }

    \inferrule*[]
        { \Gamma \textsf{ ctx } \\ \Gamma \vdash A :: \kappa \\ \alpha \notin \dom \Gamma}
        { \Gamma, \alpha :: \kappa = A \textsf{ ctx}}

    \inferrule*[]
        { \Gamma \textsf{ ctx} \\ \rhd_{\oldhat{\alpha}} \notin \Gamma \\ \oldhat{\alpha} \notin \dom \Gamma}
        { \Gamma, \rhd_{\oldhat{\alpha}} \textsf{ ctx}}

    \inferrule*[]
        { \Gamma \textsf{ ctx} \\ \oldhat{\alpha} \notin \dom \Gamma }
        { \Gamma, \oldhat{\alpha} :: \kappa \textsf{ ctx}}

    \inferrule*[]
        {\Gamma \textsf{ ctx} \\ \oldhat{\alpha} \notin \dom \Gamma \\ \Gamma \vdash \tau :: \kappa}
        { \Gamma, \oldhat{\alpha} :: \kappa = \tau \textsf{ ctx}}
\end{mathpar}
\noindent$\boxed{\Gamma \vdash A :: \kappa}$
\begin{mathpar}

    \inferrule*[]
        {\oldhat{\alpha} :: \kappa \in \Gamma}
        { \Gamma \vdash \oldhat{\alpha} :: \kappa }

    \inferrule*[]
        {\alpha :: \kappa \in \Gamma}
        { \Gamma \vdash \alpha :: \kappa }

    \inferrule*[]
        {\alpha :: \kappa = A \in \Gamma}
        { \Gamma \vdash \alpha :: \kappa }

    \inferrule*[]
        { }
        { \Gamma \vdash 1 :: \star }

    \inferrule*[]
        { \Gamma \vdash A :: \star \\ \Gamma \vdash B :: \star }
        { \Gamma \vdash A \to B :: \star }

    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash A :: \star }
        { \Gamma \vdash \forall \alpha :: \kappa. A :: \star }

    \inferrule*[]
        { \Gamma, \alpha :: \kappa_1 \vdash A :: \kappa_2}
        { \Gamma \vdash \lambda \alpha :: \kappa_1. A :: \kappa_1 \to \kappa_2}

    \inferrule*[]
        { \Gamma \vdash A :: \kappa_1 \to \kappa_2 \\ \Gamma \vdash B :: \kappa_1 }
        { \Gamma \vdash A \ B :: \kappa_2 }

    \inferrule*[]
        { \Gamma \vdash \rho \textsf{ row}}
        { \Gamma \vdash \Pi \ \rho :: \star }

    \inferrule*[]
        { \Gamma \vdash \rho \textsf{ row}}
        { \Gamma \vdash \Sigma \ \rho :: \star }    

\end{mathpar}
\noindent$\boxed{\Gamma \vdash \rho \textsf{ row}}$
\begin{mathpar}
    \inferrule*[]
        { }
        { \Gamma \vdash \cdot \textsf{ row}}

    \inferrule*[]
        { \Gamma \vdash A :: \star \\ \ell \notin \dom \rho \\ \Gamma \vdash \rho \textsf{ row}}
        { \Gamma \vdash \ell : A :: \rho \textsf{ row}}
\end{mathpar}

{\setlength{\mathindent}{0cm}
\begin{empheq}[box=\fbox]{align*}
    &\Gamma \vdash A \leadsto A'\\
    &\Gamma \vdash \rho \leadsto \rho'
\end{empheq}}
\begin{mathpar}
    \inferrule*[]
        { }
        { \Gamma[\alpha :: \kappa] \vdash \alpha \leadsto \alpha }

    \inferrule*[]
        { }
        { \Gamma[\alpha :: \kappa = A] \vdash \alpha \leadsto A }

    \inferrule*[]
        { }
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \oldhat{\alpha} \leadsto \oldhat{\alpha} }

    \inferrule*[]
        { }
        { \Gamma \vdash 1 \leadsto 1 }

    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash A \leadsto A' }
        { \Gamma \vdash \forall \alpha :: \kappa. A \leadsto \forall \alpha :: \kappa. A'}

    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash A \leadsto A' }
        { \Gamma \vdash \lambda \alpha :: \kappa. A \leadsto \lambda \alpha :: \kappa. A' }

    \inferrule*[]
        { \Gamma \vdash A \leadsto A'  }
        { \Gamma \vdash A \to B \leadsto A' \to B }


    \inferrule*[]
        { \Gamma \vdash B \leadsto B'  }
        { \Gamma \vdash A \to B \leadsto A \to B' }

    \inferrule*[]
        { \Gamma \vdash A \leadsto A'  }
        { \Gamma \vdash A \ B \leadsto A' \ B }


    \inferrule*[]
        { \Gamma \vdash B \leadsto B'  }
        { \Gamma \vdash A \ B \leadsto A \ B' }

    \inferrule*[]
        { }
        { \Gamma \vdash (\lambda \alpha :: \kappa. A) \ B \leadsto A[\alpha := B] }

    \inferrule*[]
        { \Gamma \vdash \rho \leadsto \rho' }
        { \Gamma \vdash \Pi \ \rho \leadsto \Pi \ \rho' }

    \inferrule*[]
        { \Gamma \vdash \rho \leadsto \rho' }
        { \Gamma \vdash \Sigma \ \rho \leadsto \Sigma \ \rho' }    
    \\

    \inferrule*[]
        { \Gamma \vdash A \leadsto A'}
        { \Gamma \vdash \ell : A :: \rho \leadsto \ell : A' :: \rho }

    \inferrule*[]
        { \Gamma \vdash \rho \leadsto \rho' }
        { \Gamma \vdash \ell : A :: \rho \leadsto \ell : A :: \rho' }

    \inferrule*[]
        { }
        { \Gamma \vdash \cdot \leadsto \cdot }
\end{mathpar}

{\setlength{\mathindent}{0cm}
\begin{empheq}[box=\fbox]{align*}
    &\Gamma[\oldhat{\alpha} :: \kappa] \vdash A \leadsto^\nu B \dashv \Delta\\
    &\Gamma[\oldhat{\alpha} :: \kappa] \vdash \rho \leadsto^\nu \varsigma \dashv \Delta
\end{empheq}}
\begin{mathpar}
    \inferrule*[]
        { }
        { \Gamma[\oldhat{\beta} :: \kappa][\oldhat{\alpha} :: \kappa] \vdash \oldhat{\beta} \leadsto^\nu \oldhat{\beta} \dashv \Gamma[\oldhat{\beta} :: \kappa][\oldhat{\alpha} :: \kappa] }

    \inferrule*[]
        { }
        { \Gamma[\oldhat{\alpha} :: \kappa][\oldhat{\beta} :: \kappa] \vdash \oldhat{\beta} \leadsto^\nu \oldhat{\beta_1} \dashv \Gamma[\oldhat{\beta_1} :: \kappa, \oldhat{\alpha} :: \kappa][\oldhat{\beta} :: \kappa = \oldhat{\beta_1}] }

    \inferrule*[]
        { }
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \alpha \leadsto^\nu \alpha \dashv \Gamma[\oldhat{\alpha} :: \kappa] }

    \inferrule*[]
        { \Gamma \vdash A \leadsto^\nu B \dashv \Delta }
        { \Gamma \vdash A \ C \leadsto^\nu B \ C \dashv \Delta }

    \inferrule*[]
        { \Gamma \vdash A_1 \leadsto^{\overline{\nu}} B_1 \dashv \Theta \\ \Theta \vdash [\Theta]A_2 \leadsto^\nu B_2 \dashv \Delta }
        { \Gamma \vdash A_1 \to A_2 \leadsto^\nu B_1 \to B_2 \dashv \Delta }
\end{mathpar}
\begin{mathpar}
    \inferrule*[]
        { \Gamma \vdash \lambda \alpha :: \kappa \vdash A \leadsto^\nu B \dashv \Delta, \alpha :: \kappa }
        { \Gamma \vdash \lambda \alpha :: \kappa. A \leadsto^\nu \lambda \alpha :: \kappa. B \dashv \Delta }

    \inferrule*[]
        { \Gamma[\oldhat{\beta_1} :: \kappa', \oldhat{\alpha} :: \kappa] \vdash A[\beta := \oldhat{\beta_1}] \leadsto^- B \dashv \Delta }
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \forall \beta :: \kappa'. A \leadsto^- B \dashv \Delta }

    
    \inferrule*[]
        { \Gamma[\oldhat{\alpha} :: \kappa], \beta :: \kappa' \vdash A \leadsto^+ B \dashv \Delta, \beta :: \kappa' }
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \forall \beta :: \kappa'. A \leadsto^+ B \dashv \Delta }

    \inferrule*[]
        { \Gamma[\oldhat{\alpha} :: \kappa], \beta :: \kappa' \vdash A \leadsto^\pm B \dashv \Delta, \beta :: \kappa' }
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \forall \beta :: \kappa'. A \leadsto^\pm \forall \beta :: \kappa'. B \dashv \Delta }

    \inferrule*[]
        { \Gamma \vdash \rho \leadsto \rho' \dashv \Delta }
        { \Gamma \vdash \Sigma \ \rho \leadsto \Sigma \ \rho' \dashv \Delta }

    \inferrule*[]
        { \Gamma \vdash \rho \leadsto \rho' \dashv \Delta }
        { \Gamma \vdash \Pi \ \rho \leadsto \Pi \ \rho' \dashv \Delta }
    \\
    \inferrule*[]
        { \Gamma \vdash A \leadsto^\nu A' \dashv \Theta \\ \Theta \vdash [\Theta]\rho \leadsto^\nu \varsigma \dashv \Delta }
        { \Gamma \vdash \ell : A :: \rho \leadsto^\nu \ell : A' :: \varsigma \dashv \Delta }

    \inferrule*[]
        { }
        { \Gamma \vdash \cdot \leadsto^\nu \cdot \dashv \Gamma }
\end{mathpar}

{\setlength{\mathindent}{0cm}
\begin{empheq}[box=\fbox]{align*}
    &\Gamma \vdash A \doteq B \dashv \Delta\\
    &\Gamma \vdash \rho \doteq \varsigma \dashv \Delta
\end{empheq}}
\begin{mathpar}
    \inferrule*[]
        { }
        {\Gamma \vdash 1 \doteq 1 \dashv \Gamma}

    \inferrule*[]
        { }
        { \Gamma[\alpha :: \kappa] \vdash \alpha \doteq \alpha \dashv \Gamma[\alpha :: \kappa] }

    \inferrule*[]
        { \oldhat{\alpha} \notin \textsf{fv}(\tau) \\ \Gamma[\oldhat{\alpha} :: \kappa] \vdash \tau \leadsto^\pm \sigma \dashv \Delta, \oldhat{\alpha} :: \kappa, \Theta \\ \Delta \vdash \sigma :: \kappa}
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \oldhat{\alpha} \doteq \tau \dashv \Delta, \oldhat{\alpha} :: \kappa = \sigma, \Theta}


    \inferrule*[]
        { \oldhat{\alpha} \notin \textsf{fv}(\tau) \\ \Gamma[\oldhat{\alpha} :: \kappa] \vdash \tau \leadsto^\pm \sigma \dashv \Delta, \oldhat{\alpha} :: \kappa, \Theta \\ \Delta \vdash \sigma :: \kappa}
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \tau \doteq \oldhat{\alpha} \dashv \Delta, \oldhat{\alpha} :: \kappa = \sigma, \Theta}


    \inferrule*[]
        { \Gamma \vdash A_1 \doteq B_1 \dashv \Theta \\ \Theta \vdash [\Theta]A_2 \doteq [\Theta]B_2 \dashv \Delta}
        { \Gamma \vdash A_1 \ A_2 \doteq B_1 \ B_2 \dashv \Delta}

    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash A \doteq B \dashv \Delta, \alpha :: \kappa}
        { \Gamma \vdash \lambda \alpha :: \kappa. A \doteq \lambda \alpha :: \kappa. B \dashv \Delta }

    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash A \doteq B \dashv \Delta, \alpha :: \kappa }
        { \Gamma \vdash \forall \alpha :: \kappa. A \doteq \forall \alpha :: \kappa. B \dashv \Delta }

    
    \inferrule*[]
        { \Gamma \vdash A_1 \doteq B_1 \dashv \Theta \\ \Theta \vdash [\Theta]A_2 \doteq [\Theta]B_2 \dashv \Delta }
        { \Gamma \vdash A_1 \to A_2 \doteq B_1 \to B_2 \dashv \Delta }

    \inferrule*[]
        { \Gamma \vdash \rho_1 \doteq \rho_2 \dashv \Delta }
        { \Gamma \vdash \Sigma \ \rho_1 \doteq \Sigma \ \rho_2 \dashv \Delta }

    
    \inferrule*[]
        { \Gamma \vdash \rho_1 \doteq \rho_2 \dashv \Delta }
        { \Gamma \vdash \Pi \ \rho_1 \doteq \Pi \ \rho_2 \dashv \Delta }

    \inferrule*[]
        { \Gamma \vdash A_1 \doteq A_2 \dashv \Theta \\ \Theta \vdash [\Theta]\rho_1 \doteq [\Theta]\rho_2 \dashv \Delta }
        { \Gamma \vdash \ell : A_1 :: \rho_1 \doteq \ell : A_2 :: \rho_2 \dashv \Delta }

    \inferrule*[]
        { }
        { \Gamma \vdash \cdot \doteq \cdot \dashv \Gamma }
\end{mathpar}

\noindent$\boxed{\Gamma \vdash A \leq B \dashv \Delta \leadsto \mathbb{T}}$
\begin{mathpar}
    \inferrule*[]
        { }
        { \Gamma[\alpha :: \kappa] \vdash \alpha \leq \alpha \dashv \Gamma[\alpha :: \kappa] \leadsto [\cdot]}

    \inferrule*[]
        { }
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \oldhat{\alpha} \leq \oldhat{\alpha} \dashv \Gamma[\oldhat{\alpha} :: \kappa] \leadsto [\cdot]}

    \inferrule*[]
        { }
        { \Gamma \vdash 1 \leq 1 \dashv \Gamma \leadsto [\cdot]}

    \inferrule*[]
        { \Gamma \vdash B_1 \leq A_1 \dashv \Theta \leadsto \mathbb{T}_1 \\ \Theta \vdash [\Theta]A_2 \leq [\Theta]B_2 \dashv \Delta \leadsto \mathbb{T}_2 }
        { \Gamma \vdash A_1 \to A_2 \leq B_1 \to B_2 \dashv \Delta \leadsto \lambda x : B_1. \mathbb{T}_2[[\cdot] \ (\mathbb{T}_1[x])]}

    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash A \leq B \dashv \Delta, \alpha :: \kappa \leadsto \mathbb{T} }
        { \Gamma \vdash A \leq \forall \alpha :: \kappa. B \dashv \Delta \leadsto \Lambda \alpha :: \kappa. \mathbb{T}}

    \inferrule*[]
        { \Gamma, \rhd_{\oldhat{\alpha}}, \oldhat{\alpha} :: \kappa \vdash A[\alpha := \oldhat{\alpha}] \leq B \dashv \Delta_1, \rhd_{\oldhat{\alpha}}, \Delta_2}
        { \Gamma \vdash \forall \alpha :: \kappa. A \leq B \dashv \Delta_1 \leadsto \mathbb{T}[([\cdot] \ [[\Delta_2]\oldhat{\alpha}])]}
\end{mathpar}
    % 
    % \inferrule*[]
    %     { \Gamma \vdash C_1 \doteq C_2 \dashv \Theta \\ \Theta \vdash [\Theta] A \leq [\Theta] B \dashv \Delta  }
    %     { \Gamma \vdash A \ C_1 \leq B \ C_2 \dashv \Delta }

    % \inferrule*[]
    %     { \Gamma, \alpha :: \kappa \vdash A \leq B \dashv \Delta, \alpha :: \kappa }
    %     { \Gamma \vdash \lambda \alpha :: \kappa. A \leq \lambda \alpha :: \kappa. B \dashv \Delta }
\begin{mathpar}
    \inferrule*[]
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash A \leadsto^- B \dashv \Theta \\ \Theta \vdash B :: \kappa \\ \Theta \vdash \oldhat{\alpha} \doteq B \dashv \Delta}
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash \oldhat{\alpha} \leq A \dashv \Delta}

    \inferrule*[]
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash A \leadsto^+ B \dashv \Theta \\ \Theta \vdash B :: \kappa \\ \Theta \vdash \oldhat{\alpha} \doteq B \dashv \Delta}
        { \Gamma[\oldhat{\alpha} :: \kappa] \vdash A \leq \oldhat{\alpha} \dashv \Delta}

\end{mathpar}

\noindent$\boxed{\Gamma \vdash e \Rightarrow A \dashv \Delta \leadsto f}$
\begin{mathpar}
    \inferrule*[]
        { x : A \in \Gamma }
        { \Gamma \vdash x \Rightarrow A \dashv \Gamma \leadsto x }

    \inferrule*[]
        { \Gamma \vdash e_1 \Rightarrow A \dashv \Theta \leadsto f_1 \\ \Theta \vdash [\Theta]A \bullet e_2 \Rightarrow C \dashv \Delta \leadsto \mathbb{T}, f_2 }
        { \Gamma \vdash e_1 \ e_2 \Rightarrow C  \dashv \Delta \leadsto (\mathbb{T}[f_1] \ f_2) }

    \inferrule*[]
        { \Gamma \vdash A :: \star \\ \Gamma \vdash e \Leftarrow A \dashv \Delta \leadsto f }
        { \Gamma \vdash (e : A) \Rightarrow A \dashv \Delta \leadsto f }

    % The addition of unsolved to output contexts is a bit hacky. One (perhaps more prinacipled solution) is to generalize
    % the unsolved variables on lambdas and big lambdas. 
    \inferrule*[]
        { \Gamma, \oldhat{\alpha} :: \star, x : \oldhat{\alpha} \vdash e \Rightarrow B \dashv \Delta }
        { \Gamma \vdash \lambda x. e \Rightarrow \Delta[x :: \oldhat{\alpha}]\{\oldhat{\alpha} \to B\} }

    \inferrule*[]
        { }
        { \Gamma \vdash () \Rightarrow 1 \dashv \Gamma }

    \inferrule*[]
        { \Gamma \vdash A :: \star \\ \Gamma, x : A \vdash e \Rightarrow B \dashv \Delta}
        { \Gamma \vdash \lambda (x : A). e \Rightarrow \Delta[x:A]\{ A \to B \} }
    
    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash e \Rightarrow A \dashv \Delta   }
        { \Gamma \vdash \Lambda \alpha :: \kappa. e \Rightarrow \Delta[\alpha :: \kappa]\{ \forall \alpha :: \kappa. A \} }

    \inferrule*[]
        { \Gamma \vdash e_1 \Rightarrow A \leadsto f_1 \dashv \Theta \\ \Theta, x : A \vdash e_2 \Rightarrow B \leadsto f_2 \dashv \Delta }
        { \Gamma \vdash \textsf{let } x = e_1 \textsf{ in } e_2 \Rightarrow \Delta[x : A]\{ B \} \leadsto \textsf{let } x : A = f_1 \textsf{ in } f_2}

    \inferrule*[]
        { \Gamma \vdash A :: \kappa \\ \Gamma, \alpha :: \kappa = A \vdash e \Rightarrow B \dashv \Delta \leadsto f }
        { \Gamma \vdash \textsf{let type } \alpha :: \kappa = A \textsf{ in } e \Rightarrow \Delta[\alpha :: \kappa]\{ B \} \leadsto f }

    \inferrule*[]
        { \Gamma \vdash A :: \star \\ \Gamma, f : A \vdash \lambda x. e_1 \Leftarrow A \dashv \Theta \leadsto f_1 \\ \Theta \vdash e_2 \Rightarrow B \dashv \Delta \leadsto f_2}
        { \Gamma \vdash \textsf{let rec } f : A = \lambda x. e_1 \textsf{ in } e_2 \Rightarrow \Delta[x : A]\{ B \} \leadsto \textsf{let rec } f : A = f_1 \textsf{ in } f_2}

    \inferrule*[]
        { \Gamma \vdash e \Rightarrow \Pi \ \rho \dashv \Delta \leadsto f \\ \ell : A \in \rho }
        { \Gamma \vdash e.\ell \Rightarrow A \dashv \Delta \leadsto f.\ell }

    \inferrule*[]
        { \Delta_1 = \Gamma \\ \forall 1 \leq i \leq n. \ \Delta_i \vdash e_i \Rightarrow A_i \dashv \Delta_{i + 1} \leadsto f_i  }
        { \Gamma \vdash \{ \ \ell_1 = e_1; \ldots; \ell_n = e_n \ \} \Rightarrow \Pi \ ( \ \ell_1 : A_1 :: \cdots :: \ell_n : A_n \ ) \dashv \Delta_{n + 1} \leadsto \{ \ \ell_1 = f_1; \ldots; \ell_n = f_n \ \} }

    \inferrule*[]
        { \Gamma \vdash e_1 \Rightarrow \Pi \ \rho \dashv \Delta \leadsto f_1 \\  \ell : A \in \rho \\ \Delta \vdash e_2 \Leftarrow \Delta[A] \dashv \Theta \leadsto f_2 }
        { \Gamma \vdash \{ \ e_1 \textsf{ with } \ell = e_2 \ \} \Rightarrow \Pi \ \rho \dashv \Theta \leadsto \{ \ f_1 \textsf{ with } \ell = f_2 \ \} }

    \inferrule*[]
        { \Gamma \vdash \Gamma(C) \leq \Sigma \ \rho \dashv \Theta \\ C : B \in \rho \\ \Gamma \vdash e \Leftarrow \Theta[B] \dashv \Delta \leadsto f }
        { \Gamma \vdash C \ e \Rightarrow \Sigma \ \rho \dashv \Delta \leadsto (C \ f : \Sigma \ \rho) }

    \inferrule*[]
        { \Gamma \vdash e \Rightarrow \Sigma \ \rho \dashv \Theta \leadsto f \\ \Theta_1 = \Theta, \oldhat{\alpha} :: \star \\ \forall 1 \leq i \leq n. \ \Theta_i \vdash p_i \to e_i \Leftarrow \Sigma \ \rho \to \oldhat{\alpha} \dashv \Theta_{i + 1} \leadsto q_i \to f_i}
        { \Gamma \vdash \textsf{match } e \textsf{ with } \overline{p_i \to e_i} \Rightarrow \oldhat{\alpha} \dashv \Theta_{n + 1} \leadsto \textsf{match } f \textsf{ with } \overline{q_i \to f_i}}
\end{mathpar}

\noindent$\boxed{\Gamma \vdash e \Leftarrow A \dashv \Delta \leadsto f}$
\begin{mathpar}
    \inferrule*[]
        {  }
        { \Gamma \vdash () \Leftarrow 1 \dashv \Gamma \leadsto () }

    \inferrule*[]
        { \Gamma, x : A \vdash e \Leftarrow B \dashv \Delta, x : A \leadsto f }
        { \Gamma \vdash \lambda x. e \Leftarrow A \to B \dashv \Delta \leadsto \lambda x : A. f}

    \inferrule*[]
        { \Gamma \vdash e \Rightarrow A \dashv \Theta \leadsto f \\ \Theta \vdash [\Theta]A \leq [\Theta]B \dashv \Delta \leadsto \mathbb{T}}
        { \Gamma \vdash e \Leftarrow B \dashv \Delta \leadsto \mathbb{T}[f]}
    
    \inferrule*[]
        { \Gamma, \alpha :: \kappa \vdash e \Leftarrow A \dashv \Delta, \alpha :: \kappa \leadsto f}
        { \Gamma \vdash e \Leftarrow \forall \alpha :: \kappa. A \dashv \Delta \leadsto \Lambda \alpha :: \kappa. f}

    \inferrule*[]
        { \Delta_1 = \Gamma \\ \forall 1 \leq i \leq n. \ \Delta_i \vdash e_i \Leftarrow A_i \dashv \Delta_{i + 1} \leadsto f_i }
        { \Gamma \vdash \{ \ \ell_1 = e_1; \ldots; \ell_n = e_n \ \} \Leftarrow \Pi \ ( \ \ell_1 : A_1 :: \cdots :: \ell_n : A_n \ ) \dashv \Delta_{n + 1} \leadsto \{ \ \ell_1 = f_1; \ldots; \ell_n = f_n \ \} }

    \inferrule*[]
        { \Gamma \vdash e_1 \Leftarrow \Pi \ \rho \leadsto f_1 \\  \ell : A \in \rho \\ \Gamma \vdash e_2 \Leftarrow A \leadsto f_2 }
        { \Gamma \vdash \{ \ e_1 \textsf{ with } \ell = e_2 \ \} \Leftarrow \Pi \ \rho \dashv \Delta \leadsto \{ \ f_1 \textsf{ with } \ell = f_2 \ \} }

    \inferrule*[]
        { C : A \in \rho \\ \Gamma \vdash e \Leftarrow A \dashv \Delta \leadsto f }
        { \Gamma \vdash C \ e \Leftarrow \Sigma \ \rho \dashv \Delta \leadsto (C \ f : \Sigma \ \rho) }
    
    \inferrule*[]
        { \Gamma \vdash e \Rightarrow \Sigma \ \rho \leadsto f \\ \forall 1 \leq i \leq n. \ \Gamma \vdash p_i \to e_i \Leftarrow \Sigma \ \rho \to A \leadsto q_i \to f_i}
        { \Gamma \vdash \textsf{match } e \textsf{ with } \overline{p_i \to e_i} \Leftarrow A \leadsto \textsf{match } f \textsf{ with } \overline{q_i \to f_i}}
\end{mathpar}

\noindent$\boxed{\Gamma \vdash A \bullet e \Rightarrow C \dashv \Delta \leadsto \mathbb{T}, f}$
\begin{mathpar}
    \inferrule*[]
        { \Gamma, \oldhat{\alpha} :: \kappa \vdash A[\alpha := \oldhat{\alpha}] \bullet e \Rightarrow C \dashv \Delta \leadsto \mathbb{T}, f }
        { \Gamma \vdash \forall \alpha :: \kappa. A \bullet e \Rightarrow C \dashv \Delta \leadsto \mathbb{T}[([\cdot] \ [\oldhat{\alpha}])], f }

    \inferrule*[]
        { \Gamma \vdash e \Leftarrow A \dashv \Delta \leadsto f }
        { \Gamma \vdash A \to C \bullet e \Rightarrow C \dashv \Delta \leadsto [\cdot], f }

    \inferrule*[]
        { \Gamma[\oldhat{\alpha_1} :: \star, \oldhat{\alpha_2} :: \star, \oldhat{\alpha} :: \star = \oldhat{\alpha_1} \to \oldhat{\alpha_2}] \vdash e \Leftarrow \oldhat{\alpha_1} \dashv \Delta \leadsto f }
        { \Gamma[\oldhat{\alpha} :: \star] \vdash \oldhat{\alpha} \bullet e \Rightarrow \oldhat{\alpha_2} \dashv \Delta \leadsto [\cdot], f }
\end{mathpar}

\noindent(\textit{Note}: Implicit $\beta$-reductions are performed on all judgements $\mathcal{J}$ with \textit{input} types)
\begin{align*}
    (\Gamma_1, \gamma, \Gamma_2)\{ A \} = \Gamma_2[A] \dashv \Gamma_1, \textsf{unsolved}(\Gamma_2)
\end{align*}

